Loading...
Searching...
No Matches
juce::MidiKeyboardState Class Reference

## Detailed Description

Represents a piano keyboard, keeping track of which keys are currently pressed.

This object can parse a stream of midi events, using them to update its idea of which keys are pressed for each individual midi channel.

When keys go up or down, it can broadcast these events to listener objects.

It also allows key up/down events to be triggered with its noteOn() and noteOff() methods, and midi messages for these events will be merged into the midi stream that gets processed by processNextMidiBuffer().

The documentation for this class was generated from the following file:

- juce_audio_basics/midi/juce_MidiKeyboardState.h

## Classes

class | Listener
| Receives events from a MidiKeyboardState object. More...

## Public Member Functions

| MidiKeyboardState ()
void | reset ()
| Resets the state of the object.
bool | isNoteOn (int midiChannel, int midiNoteNumber) const noexcept
| Returns true if the given midi key is currently held down for the given midi channel.
bool | isNoteOnForChannels (int midiChannelMask, int midiNoteNumber) const noexcept
| Returns true if the given midi key is currently held down on any of a set of midi channels.
void | noteOn (int midiChannel, int midiNoteNumber, float velocity)
| Turns a specified note on.
void | noteOff (int midiChannel, int midiNoteNumber, float velocity)
| Turns a specified note off.
void | allNotesOff (int midiChannel)
| This will turn off any currently-down notes for the given midi channel.
void | processNextMidiEvent (const MidiMessage &message)
| Looks at a key-up/down event and uses it to update the state of this object.
void | processNextMidiBuffer (MidiBuffer &buffer, int startSample, int numSamples, bool injectIndirectEvents)
| Scans a midi stream for up/down events and adds its own events to it.
void | addListener (Listener *listener)
| Registers a listener for callbacks when keys go up or down.
void | removeListener (Listener *listener)
| Deregisters a listener.

## Constructors and Destructors

## MidiKeyboardState()

juce::MidiKeyboardState::MidiKeyboardState | ( |  | ) |

Referenced by juce::MidiKeyboardState::Listener::handleNoteOff(), juce::MidiKeyboardState::Listener::handleNoteOn(), and removeListener().

## Member Functions

## reset()

void juce::MidiKeyboardState::reset | ( |  | ) |

Resets the state of the object.

All internal data for all the channels is reset, but no events are sent as a result.

If you want to release any keys that are currently down, and to send out note-up midi messages for this, use the allNotesOff() method instead.

## isNoteOn()

bool juce::MidiKeyboardState::isNoteOn | ( | int | midiChannel,
|  | int | midiNoteNumber ) const

noexcept

Returns true if the given midi key is currently held down for the given midi channel.

The channel number must be between 1 and 16. If you want to see if any notes are on for a range of channels, use the isNoteOnForChannels() method.

## isNoteOnForChannels()

bool juce::MidiKeyboardState::isNoteOnForChannels | ( | int | midiChannelMask,
|  | int | midiNoteNumber ) const

noexcept

Returns true if the given midi key is currently held down on any of a set of midi channels.

The channel mask has a bit set for each midi channel you want to test for - bit 0 = midi channel 1, bit 1 = midi channel 2, etc.

If a note is on for at least one of the specified channels, this returns true.

## noteOn()

void juce::MidiKeyboardState::noteOn | ( | int | midiChannel,
|  | int | midiNoteNumber,
|  | float | velocity )

Turns a specified note on.

This will cause a suitable midi note-on event to be injected into the midi buffer during the next call to processNextMidiBuffer().

It will also trigger a synchronous callback to the listeners to tell them that the key has gone down.

## noteOff()

void juce::MidiKeyboardState::noteOff | ( | int | midiChannel,
|  | int | midiNoteNumber,
|  | float | velocity )

Turns a specified note off.

This will cause a suitable midi note-off event to be injected into the midi buffer during the next call to processNextMidiBuffer().

It will also trigger a synchronous callback to the listeners to tell them that the key has gone up.

But if the note isn't actually down for the given channel, this method will in fact do nothing.

## allNotesOff()

void juce::MidiKeyboardState::allNotesOff | ( | int | midiChannel | ) |

This will turn off any currently-down notes for the given midi channel.

If you pass 0 for the midi channel, it will in fact turn off all notes on all channels.

Calling this method will make calls to noteOff(), so can trigger synchronous callbacks and events being added to the midi stream.

## processNextMidiEvent()

void juce::MidiKeyboardState::processNextMidiEvent | ( | const MidiMessage & | message | ) |

Looks at a key-up/down event and uses it to update the state of this object.

To process a buffer full of midi messages, use the processNextMidiBuffer() method instead.

## processNextMidiBuffer()

void juce::MidiKeyboardState::processNextMidiBuffer | ( | MidiBuffer & | buffer,
|  | int | startSample,
|  | int | numSamples,
|  | bool | injectIndirectEvents )

Scans a midi stream for up/down events and adds its own events to it.

This will look for any up/down events and use them to update the internal state, synchronously making suitable callbacks to the listeners.

If injectIndirectEvents is true, then midi events to produce the recent noteOn() and noteOff() calls will be added into the buffer.

Only the section of the buffer whose timestamps are between startSample and (startSample + numSamples) will be affected, and any events added will be placed between these times.

If you're going to use this method, you'll need to keep calling it regularly for it to work satisfactorily.

To process a single midi event at a time, use the processNextMidiEvent() method instead.

## addListener()

void juce::MidiKeyboardState::addListener | ( | Listener * | listener | ) |

Registers a listener for callbacks when keys go up or down.

See also
  removeListener

## removeListener()

void juce::MidiKeyboardState::removeListener | ( | Listener * | listener | ) |

Deregisters a listener.

See also
  addListener

References MidiKeyboardState().

### Purchase

Get JUCE

### Discover

What's New in JUCE Features

### Learn

Documentaion Tutorials Made with JUCE Resources

### Support

JUCE Forum Newsletter Archive

### About

Contact Us JUCE Legal JUCE Licensing FAQ

### Events

Audio Developer Conference
© Raw Material Software Limited